
// The package containing our stubs.
import HelloApp1.*;

// HelloClient will use the naming service.
import org.omg.CosNaming.*;

// The package containing special exceptions thrown by the name service.
import org.omg.CosNaming.NamingContextPackage.*;

// All CORBA applications need these classes.
import org.omg.CORBA.*;

// Needed for the applet.
import java.awt.Graphics;
import java.util.*;

public class HelloApplet extends java.applet.Applet {
   Hello helloRef;
   CallBackHelloImpl servent;
   public void init() {
    try {
      System.out.println("Initializing distributed object references ");
      /* create and initialize the ORB */


       Properties props = new Properties();
       props.put("org.omg.CORBA.ORBClass", "com.ooc.CORBA.ORB");
       props.put("org.omg.CORBA.ORBSingletonClass",
                      "com.ooc.CORBA.ORBSingleton");
       ORB orb = ORB.init(this, props);
       BOA boa=((com.ooc.CORBA.ORB)orb).BOA_init(this,props);
       servent=new CallBackHelloImpl();
       orb.connect(servent);

       System.out.println("Initialized ORB");
       org.omg.CORBA.Object objRef =orb.string_to_object("iioploc://128.230.8.140:5556/NameService");
       NamingContext ncRef = NamingContextHelper.narrow(objRef);
       /* resolve the Object Reference in Naming */
       NameComponent nc = new NameComponent("HelloServer", "");
       NameComponent path[] = {nc};
       helloRef = HelloHelper.narrow(ncRef.resolve(path));
       System.out.println("Reference to HelloServer resolved");
       message = helloRef.sayHello(servent);
    } catch (Exception e) {
        System.out.println("HelloApplet exception: " + e.getMessage());
        e.printStackTrace(System.out);
    }
   }
   String message = "";
   public void paint(Graphics g) {
    g.drawString(message, 25, 50);
   }

}

class CallBackHelloImpl extends _CallBackHelloImplBase {
	public String hello() {
		return "\n Hello world buddy!! I have been called.";
	}
}
